module Raml where 

import Tct.Interactive
import Tct.Instances hiding (toDP)
import qualified Termlib.Repl as TR
import Tct.Configuration
import qualified Tct.Method.DP.DependencyGraph as DG
import Abbrevs
  

toDP = 
  (dependencyTuples <> (dependencyPairs >>> try usableRules >>> try (wg 2 1 `wgOn` WgOnTrs)))
  >>> try removeInapplicable
  >>> try simpDP

-- partitionIndependentCycle = some $ 
--   exhaustively (decompose >>> try cleanSuffix)
--   where decompose = decomposeBy (selAllOf selCycleIndependentSG)

            
simpDP = 
  try cleanSuffix
  >>> te decomposeIndependentSG
  >>> te removeHeads
  >>> try trivial
  >>> try usableRules 

semantic methods i = whenNonTrivial $ 
  (when (PopStar `elem` methods) (peAny (spopstarPS `withDegree` Just i)))
  <> 
  (when (Matrices `elem` methods) 
   (peAny (mx i i) 
    <||> peAny (mx (i + 1) i)
    <||> when (i == 1) (peAny (mx 3 1) 
                        <||> peAny (mx 3 1 `withBits` 3)))
   <||> when (Polys `elem` methods && (i == 2 || i == 3)) (peAny (poly `withDegree` Just i)))
  where peAny p = p `withPEOn` selAnyOf (selLeafCWDG `selInter` selStricts)>>> try cleanUpTail

semantic' = semantic [PopStar, Matrices, Polys] 


semantics methods maxdeg maybeTO = force $ te (shift maxdeg)
  where
    shift 0 = some $ rl 0
    shift n = some $ shift (n - 1) <> rl n
    
    rl = withTO . semantic methods
                    
    withTO t = maybe (some t) (\ (Nat n) -> some $ timeout n t) maybeTO

semantics' = semantics [PopStar, Matrices, Polys] 2 Nothing

decomposeFC methods maxdeg maybeTO = 
  timed $ 
  decomposeDG `solveUpperWith` (try simpDPRHS 
                                >>> try simpDP 
                                >>> try shiftDPs 
                                >>| empty) 
  >>> te decomposeIndependentSG >>> try simpDP 
  where 
    shiftDPs = semantics methods maxdeg maybeTO
  
decomposeFC' maxdeg = decomposeFC [PopStar,Matrices,Polys] maxdeg Nothing

raml (maybeTO :+: greedy :+: Nat maxdeg :+: basetechniques) = 
  try toInnermost 
  >>> try toDP 
  >>> te (timeout 3 (decomposeAnyWith $ poly `withDegree` Just 2))
  >>> try shiftRulesSuccessively 
  >>!! timed decomposing
  where 
    decomposing 
      | greedy = some $ 
                 te decomp >>> try shiftDPs >>!! empty
      | otherwise = some $ 
                    try shiftDPs >>!! iteProgress decomp decomposing empty
      where 
        shiftDPs = semantics basetechniques maxdeg maybeTO
        decomp   = decomposeFC basetechniques maxdeg maybeTO
